/*
 * MS comctl32.dll and new testcomctl32.dll Test
 *
 * Copyright (C) 2002 Zoltan Nagy   nagyzoli@drotposta.hu
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <windows.h>
#include "resource.h"

# ifdef UNICODE
#  define WINELIB_NAME_AW(func) func##W
# else
#  define WINELIB_NAME_AW(func) func##A
# endif  /* UNICODE */
# define DECL_WINELIB_TYPE_AW(type)  typedef WINELIB_NAME_AW(type) type;

#ifdef WINE_TEST_WINDOWS
#include <commctrl.h>
#else
#include "commctrl.h"
#endif

BOOL OnCreate(HWND,WPARAM wParam, LPARAM lParam);
BOOL OnDestroy(WPARAM wParam, LPARAM lParam);

/*
#include <string.h>

#include "winbase.h"
#include "wine/unicode.h"
#include "commctrl.h"
#include "comctl32.h"
#include "imagelist.h"
#include "wine/debug.h"

*/
/*
typedef int (*MYPROC)(); 

void dlltest()
{
	HMODULE hinstLib;
	MYPROC ProcAdd; 
	int ret;

	hinstLib=LoadLibrary("testcomctl32.dll");
	if (hinstLib != NULL) 
	{ 
		ProcAdd = (MYPROC) GetProcAddress(hinstLib, "test"); 

		// If the function address is valid, call the function.

		if(ProcAdd != NULL)
			ret=(ProcAdd)();//call proc 

		// Free the DLL module.
		FreeLibrary(hinstLib); 
	} 
};
*/
/*
int WINAPI WinMain (HINSTANCE hInst,HINSTANCE hPrevInstance,LPSTR lpszCmdLine, int nCmdShow)
{
	dlltest();
	return 1;
};
*/

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_TEST);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_TEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= GetStockObject(GRAY_BRUSH);//(HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_TEST;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   INITCOMMONCONTROLSEX ex;

   hInst = hInstance; // Store instance handle in our global variable
   ZeroMemory(&ex,sizeof(ex));
   ex.dwSize=sizeof(ex);
   ex.dwICC=ICC_ANIMATE_CLASS|ICC_BAR_CLASSES|ICC_COOL_CLASSES |ICC_DATE_CLASSES|ICC_HOTKEY_CLASS|
	   ICC_INTERNET_CLASSES|ICC_LISTVIEW_CLASSES|ICC_PAGESCROLLER_CLASS|ICC_PROGRESS_CLASS |
	   ICC_TAB_CLASSES|ICC_TREEVIEW_CLASSES|ICC_UPDOWN_CLASS |ICC_USEREX_CLASSES;//other ICC_WIN95_CLASSES 
   InitCommonControlsEx(&ex);

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
//	PAINTSTRUCT ps;
//	HDC hdc;

	switch (message) 
	{
	case WM_CREATE:
		if(! OnCreate(hWnd,wParam,lParam))
		{
			char str[256];
			sprintf(str,"OnCreate error: %d",GetLastError());
			MessageBox(hWnd,str,"Message",MB_OK);
		}
		return 1;
	break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
/*	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
*/
	case WM_DESTROY:
		OnDestroy(wParam,lParam);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
HWND hListView;

#define ListView_SetItemCount(hwndLV, cItems) \
  SNDMSG((hwndLV), LVM_SETITEMCOUNT, (WPARAM)(cItems), 0)
//#define ListView_InsertColumn(hwnd, iCol, pcol) \
  //  (int)SNDMSG((hwnd), LVM_INSERTCOLUMNA, (WPARAM)(int)(iCol), (LPARAM)(const LV_COLUMN *)(pcol))

HTREEITEM AddItemToTree(HWND hwndTV, LPSTR lpszItem, int nLevel)
{ 
    TVITEM tvi; 
    TVINSERTSTRUCT tvins; 
    static HTREEITEM hPrev = (HTREEITEM) TVI_FIRST; 
    static HTREEITEM hPrevRootItem = NULL; 
    static HTREEITEM hPrevLev2Item = NULL; 
//    HTREEITEM hti; 
 
    tvi.mask = TVIF_TEXT | TVIF_PARAM; 
 
    // Set the text of the item. 
    tvi.pszText = lpszItem; 
    tvi.cchTextMax = lstrlen(lpszItem); 
 
    // Assume the item is not a parent item, so give it a 
    // document image. 
//    tvi.iImage = g_nDocument; 
//    tvi.iSelectedImage = g_nDocument; 
 
    // Save the heading level in the item's application-defined 
    // data area. 
    tvi.lParam = (LPARAM) nLevel; 
 
    tvins.item = tvi; 
    tvins.hInsertAfter = hPrev; 
 
    // Set the parent item based on the specified level. 
    if (nLevel == 1) 
        tvins.hParent = TVI_ROOT; 
    else if (nLevel == 2) 
        tvins.hParent = hPrevRootItem; 
    else 
        tvins.hParent = hPrevLev2Item; 
 
    // Add the item to the tree-view control. 
    hPrev = (HTREEITEM) SendMessage(hwndTV, TVM_INSERTITEM, 0, 
         (LPARAM) (LPTVINSERTSTRUCT) &tvins); 
 
    // Save the handle to the item. 
    if (nLevel == 1) 
        hPrevRootItem = hPrev; 
    else if (nLevel == 2) 
        hPrevLev2Item = hPrev; 
 
    // The new item is a child item. Give the parent item a 
    // closed folder bitmap to indicate it now has child items. 
/*    if (nLevel > 1) { 
        hti = TreeView_GetParent(hwndTV, hPrev); 
        tvi.mask = 0;//TVIF_IMAGE | TVIF_SELECTEDIMAGE; 
        tvi.hItem = hti; 
       tvi.iImage = g_nClosed; 
        tvi.iSelectedImage = g_nClosed; 
        TreeView_SetItem(hwndTV, &tvi); 
    } 
 */
    return hPrev; 
} 
typedef struct tagPETINFO
{
	char szKind[10];
	char szBreed[50];
	char szPrice[20];
}PETINFO;

// A PETINFO variable is declared and initialized as follows:
PETINFO rgPetInfo[ ] = 
{
{"Dog", "Poodle", "$300.00"},
{"Cat", "Siamese", "$100.00"},
{"Fish", "Angel Fish", "$10.00"},
};

BOOL OnCreate(HWND hwnd,WPARAM wParam, LPARAM lParam)
{
	DWORD dwStyle;
	int x,y,max_h,w,h,ret,index;
	LV_COLUMN   lvColumn;
	LVITEM lvI;

	x=10;y=10;
	w=70;h=24;
	max_h=h;
	hListView = CreateWindowEx(WS_EX_STATICEDGE,"EDIT","edit box",WS_CHILD|WS_VISIBLE|WS_TABSTOP,//WC_LISTVIEWA
      x,y,w,h, hwnd, NULL, hInst, NULL);
	x+=w+10;
	h=16;w=80;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,PROGRESS_CLASSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//WC_LISTVIEWA
      x,y,w,h, hwnd, NULL, hInst, NULL);
	SendMessage(hListView,PBM_SETRANGE,0,MAKELPARAM(0,100));
	SendMessage(hListView,PBM_SETPOS,50,0);
	x+=w+10;
	h=100;w=150;
	if(max_h<h)max_h=h;
	dwStyle =   WS_TABSTOP | 
            WS_CHILD | 
            WS_BORDER | 
            WS_VISIBLE |
            LVS_AUTOARRANGE |
            LVS_REPORT ;
//            LVS_OWNERDATA |
//			LVS_SHOWSELALWAYS |
//			LVS_SINGLESEL |
//			LVS_EX_FULLROWSELECT |
//			LVS_AUTOARRANGE;// |
//			LVS_OWNERDRAWFIXED;
//			LVS_NOSORTHEADER;
//			LVS_NOLABELWRAP ;//|
//	LVS_OWNERDRAWFIXED   ;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,WC_LISTVIEWW,NULL,dwStyle,//
      x,y,w,h, hwnd, NULL, hInst, NULL);
	//initialize the columns
	ZeroMemory(&lvColumn,sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;// | LVCF_SUBITEM;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = 120;
	lvColumn.pszText = "First";
	lvColumn.cchTextMax =sizeof(lvColumn.pszText);
	ret=ListView_InsertColumn(hListView,0,&lvColumn);
	lvColumn.pszText = "Second";
	ret=ListView_InsertColumn(hListView,1,&lvColumn);

	// Some code to create the list-view control.

	// Initialize LVITEM members that are common to all items. 
	lvI.mask = LVIF_TEXT  | LVIF_PARAM | LVIF_STATE; //| LVIF_IMAGE
	lvI.state = 0; 
	lvI.stateMask = 0; 

	// Initialize LVITEM members that are different for each item. 
	for (index = 0; index < 3; index++)
	{
   		lvI.iItem = index;
		lvI.iImage = index;
		lvI.iSubItem = 0;
		lvI.lParam = (LPARAM) &rgPetInfo[index];
		lvI.pszText=rgPetInfo[lvI.iItem].szKind;

//		lvI.pszText = LPSTR_TEXTCALLBACK; // sends an LVN_GETDISPINFO
											// message.									  
		
	if(ListView_InsertItem(hListView, &lvI) == -1)
		;
	}
//	ret=ListView_SetItemCount(hListView,100);

	x+=w+10;
	h=30;w=120;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,DATETIMEPICK_CLASSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//
      x,y,w,h, hwnd, NULL, hInst, NULL);
	x+=w+10;
	h=200;w=250;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,MONTHCAL_CLASSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//
      x,y,w,h, hwnd, NULL, hInst, NULL);


	//new line
	x=10;y+=max_h;max_h=0;
	h=100;w=100;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,ANIMATE_CLASSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//
      x,y-50,w,h, hwnd, NULL, hInst, NULL);
	ret=Animate_Open(hListView,"filecopy.avi");//MAKEINTRESOURCE(IDR_WAIT_AVI)
	ret=Animate_Play(hListView,
		-1,//tl
		-1,//ig
		-1);//ismtls-vgtelen

	x+=w+10;
	h=24;w=150;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,WC_IPADDRESSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//
      x,y,w,h, hwnd, NULL, hInst, NULL);

	h=24;w=30;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,UPDOWN_CLASSW,NULL,WS_CHILD|WS_VISIBLE|WS_TABSTOP,//
      x,y+30,w,h, hwnd, NULL, hInst, NULL);
	w=150;

	x+=w+10;
	h=100;w=150;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(WS_EX_STATICEDGE,WC_TREEVIEWW,NULL,WS_VISIBLE | WS_CHILD | WS_BORDER | TVS_HASLINES,//
      x,y,w,h, hwnd, NULL, hInst, NULL);
	AddItemToTree(hListView,"First",0);
	AddItemToTree(hListView,"Second",0);
	AddItemToTree(hListView,"Second level 2",1);
	AddItemToTree(hListView,"Second level 3",2);
	AddItemToTree(hListView,"Second level 3B",2);
	AddItemToTree(hListView,"Second level 4",3);
	AddItemToTree(hListView,"Second level 4B",3);
	AddItemToTree(hListView,"Second level 4C",3);
	AddItemToTree(hListView,"Second level 5 end",4);

	x+=w+10;
	h=24;w=150;
	if(max_h<h)max_h=h;
	hListView = CreateWindowExW(0,STATUSCLASSNAMEW,NULL,SBARS_SIZEGRIP |WS_CHILD,//
      x,y,w,h, hwnd, NULL, hInst, NULL);
	SendMessage(hListView,WM_SETTEXT,0,(LPARAM)"this is a test");

	if(! hListView)return 0;
	return 1;
};
BOOL OnDestroy(WPARAM wParam, LPARAM lParam)
{
	return 1;
};

